# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 15
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class CheckSettingsSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action': 'str',
        'stig_path': 'str'
    }

    attribute_map = {
        'action': 'action',
        'stig_path': 'stig_path'
    }

    def __init__(self, action=None, stig_path=None):  # noqa: E501
        """CheckSettingsSettings - a model defined in Swagger"""  # noqa: E501

        self._action = None
        self._stig_path = None
        self.discriminator = None

        if action is not None:
            self.action = action
        if stig_path is not None:
            self.stig_path = stig_path

    @property
    def action(self):
        """Gets the action of this CheckSettingsSettings.  # noqa: E501

        Action to be taken on encountering security anomalies  # noqa: E501

        :return: The action of this CheckSettingsSettings.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this CheckSettingsSettings.

        Action to be taken on encountering security anomalies  # noqa: E501

        :param action: The action of this CheckSettingsSettings.  # noqa: E501
        :type: str
        """
        allowed_values = ["celog", "reboot", "shutdown"]  # noqa: E501
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def stig_path(self):
        """Gets the stig_path of this CheckSettingsSettings.  # noqa: E501

        Security Hardening file path  # noqa: E501

        :return: The stig_path of this CheckSettingsSettings.  # noqa: E501
        :rtype: str
        """
        return self._stig_path

    @stig_path.setter
    def stig_path(self, stig_path):
        """Sets the stig_path of this CheckSettingsSettings.

        Security Hardening file path  # noqa: E501

        :param stig_path: The stig_path of this CheckSettingsSettings.  # noqa: E501
        :type: str
        """
        if stig_path is not None and len(stig_path) > 4096:
            raise ValueError("Invalid value for `stig_path`, length must be less than or equal to `4096`")  # noqa: E501
        if stig_path is not None and len(stig_path) < 0:
            raise ValueError("Invalid value for `stig_path`, length must be greater than or equal to `0`")  # noqa: E501

        self._stig_path = stig_path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CheckSettingsSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
